/*
BotV2

Bot API v2

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package botapiv2

import (
	"encoding/json"
)

// checks if the Block type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &Block{}

// Block struct for Block
type Block struct {
	Id string `json:"id"`
	Type BlockType `json:"type"`
	Name string `json:"name"`
	Enabled bool `json:"enabled"`
	Messages []Message `json:"messages,omitempty"`
	ResponseWait *ResponseWait `json:"response_wait,omitempty"`
	// Duration string, eg. `1s`, `1m15s`
	FinishWait *string `json:"finish_wait,omitempty"`
	StartCondition *Condition `json:"start_condition,omitempty"`
	Jumps []Jump `json:"jumps,omitempty"`
}

// NewBlock instantiates a new Block object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewBlock(id string, type_ BlockType, name string, enabled bool) *Block {
	this := Block{}
	this.Id = id
	this.Type = type_
	this.Name = name
	this.Enabled = enabled
	return &this
}

// NewBlockWithDefaults instantiates a new Block object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewBlockWithDefaults() *Block {
	this := Block{}
	return &this
}

// GetId returns the Id field value
func (o *Block) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *Block) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *Block) SetId(v string) {
	o.Id = v
}

// GetType returns the Type field value
func (o *Block) GetType() BlockType {
	if o == nil {
		var ret BlockType
		return ret
	}

	return o.Type
}

// GetTypeOk returns a tuple with the Type field value
// and a boolean to check if the value has been set.
func (o *Block) GetTypeOk() (*BlockType, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Type, true
}

// SetType sets field value
func (o *Block) SetType(v BlockType) {
	o.Type = v
}

// GetName returns the Name field value
func (o *Block) GetName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Name
}

// GetNameOk returns a tuple with the Name field value
// and a boolean to check if the value has been set.
func (o *Block) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Name, true
}

// SetName sets field value
func (o *Block) SetName(v string) {
	o.Name = v
}

// GetEnabled returns the Enabled field value
func (o *Block) GetEnabled() bool {
	if o == nil {
		var ret bool
		return ret
	}

	return o.Enabled
}

// GetEnabledOk returns a tuple with the Enabled field value
// and a boolean to check if the value has been set.
func (o *Block) GetEnabledOk() (*bool, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Enabled, true
}

// SetEnabled sets field value
func (o *Block) SetEnabled(v bool) {
	o.Enabled = v
}

// GetMessages returns the Messages field value if set, zero value otherwise.
func (o *Block) GetMessages() []Message {
	if o == nil || IsNil(o.Messages) {
		var ret []Message
		return ret
	}
	return o.Messages
}

// GetMessagesOk returns a tuple with the Messages field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Block) GetMessagesOk() ([]Message, bool) {
	if o == nil || IsNil(o.Messages) {
		return nil, false
	}
	return o.Messages, true
}

// HasMessages returns a boolean if a field has been set.
func (o *Block) HasMessages() bool {
	if o != nil && !IsNil(o.Messages) {
		return true
	}

	return false
}

// SetMessages gets a reference to the given []Message and assigns it to the Messages field.
func (o *Block) SetMessages(v []Message) {
	o.Messages = v
}

// GetResponseWait returns the ResponseWait field value if set, zero value otherwise.
func (o *Block) GetResponseWait() ResponseWait {
	if o == nil || IsNil(o.ResponseWait) {
		var ret ResponseWait
		return ret
	}
	return *o.ResponseWait
}

// GetResponseWaitOk returns a tuple with the ResponseWait field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Block) GetResponseWaitOk() (*ResponseWait, bool) {
	if o == nil || IsNil(o.ResponseWait) {
		return nil, false
	}
	return o.ResponseWait, true
}

// HasResponseWait returns a boolean if a field has been set.
func (o *Block) HasResponseWait() bool {
	if o != nil && !IsNil(o.ResponseWait) {
		return true
	}

	return false
}

// SetResponseWait gets a reference to the given ResponseWait and assigns it to the ResponseWait field.
func (o *Block) SetResponseWait(v ResponseWait) {
	o.ResponseWait = &v
}

// GetFinishWait returns the FinishWait field value if set, zero value otherwise.
func (o *Block) GetFinishWait() string {
	if o == nil || IsNil(o.FinishWait) {
		var ret string
		return ret
	}
	return *o.FinishWait
}

// GetFinishWaitOk returns a tuple with the FinishWait field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Block) GetFinishWaitOk() (*string, bool) {
	if o == nil || IsNil(o.FinishWait) {
		return nil, false
	}
	return o.FinishWait, true
}

// HasFinishWait returns a boolean if a field has been set.
func (o *Block) HasFinishWait() bool {
	if o != nil && !IsNil(o.FinishWait) {
		return true
	}

	return false
}

// SetFinishWait gets a reference to the given string and assigns it to the FinishWait field.
func (o *Block) SetFinishWait(v string) {
	o.FinishWait = &v
}

// GetStartCondition returns the StartCondition field value if set, zero value otherwise.
func (o *Block) GetStartCondition() Condition {
	if o == nil || IsNil(o.StartCondition) {
		var ret Condition
		return ret
	}
	return *o.StartCondition
}

// GetStartConditionOk returns a tuple with the StartCondition field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Block) GetStartConditionOk() (*Condition, bool) {
	if o == nil || IsNil(o.StartCondition) {
		return nil, false
	}
	return o.StartCondition, true
}

// HasStartCondition returns a boolean if a field has been set.
func (o *Block) HasStartCondition() bool {
	if o != nil && !IsNil(o.StartCondition) {
		return true
	}

	return false
}

// SetStartCondition gets a reference to the given Condition and assigns it to the StartCondition field.
func (o *Block) SetStartCondition(v Condition) {
	o.StartCondition = &v
}

// GetJumps returns the Jumps field value if set, zero value otherwise.
func (o *Block) GetJumps() []Jump {
	if o == nil || IsNil(o.Jumps) {
		var ret []Jump
		return ret
	}
	return o.Jumps
}

// GetJumpsOk returns a tuple with the Jumps field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Block) GetJumpsOk() ([]Jump, bool) {
	if o == nil || IsNil(o.Jumps) {
		return nil, false
	}
	return o.Jumps, true
}

// HasJumps returns a boolean if a field has been set.
func (o *Block) HasJumps() bool {
	if o != nil && !IsNil(o.Jumps) {
		return true
	}

	return false
}

// SetJumps gets a reference to the given []Jump and assigns it to the Jumps field.
func (o *Block) SetJumps(v []Jump) {
	o.Jumps = v
}

func (o Block) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o Block) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	toSerialize["type"] = o.Type
	toSerialize["name"] = o.Name
	toSerialize["enabled"] = o.Enabled
	if !IsNil(o.Messages) {
		toSerialize["messages"] = o.Messages
	}
	if !IsNil(o.ResponseWait) {
		toSerialize["response_wait"] = o.ResponseWait
	}
	if !IsNil(o.FinishWait) {
		toSerialize["finish_wait"] = o.FinishWait
	}
	if !IsNil(o.StartCondition) {
		toSerialize["start_condition"] = o.StartCondition
	}
	if !IsNil(o.Jumps) {
		toSerialize["jumps"] = o.Jumps
	}
	return toSerialize, nil
}

type NullableBlock struct {
	value *Block
	isSet bool
}

func (v NullableBlock) Get() *Block {
	return v.value
}

func (v *NullableBlock) Set(val *Block) {
	v.value = val
	v.isSet = true
}

func (v NullableBlock) IsSet() bool {
	return v.isSet
}

func (v *NullableBlock) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableBlock(val *Block) *NullableBlock {
	return &NullableBlock{value: val, isSet: true}
}

func (v NullableBlock) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableBlock) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


